﻿//########################
//InDesignCS3で選択されたセル内の文字が
//一行になるように長体をかけます。
//このスクリプトは市川せうぞーさんの名もないテクノ手の
//http://d.hatena.ne.jp/seuzo/20080923/1222106561を参考にさせていただきました。
//作者の市川せうぞーさんありがとうございました。
//なおどのようなカズタマイズかわかりやすくするため変数名もなるべくそのままにしています。
//たけうちとおる
//########################

//ダイアログ表示のおまじない
app.scriptPreferences.userInteractionLevel=1699311169;

main();

function main(){
	if (app.documents.length == 0){
		alert("ドキュメントを開いてください");
		return;
	}
	if (app.selection.length == 0){
		alert("セルを選択してください");
		return;
	}
	myDocu = app.activeDocument;
	mySele = myDocu.selection;
	for(var s = 0; s<app.selection.length; s++){
		table_choutai(app.selection[s]);
	}
}

function table_choutai(myObj){
	var seltype = myObj.constructor.name
	if(seltype == "Cell" ||  seltype == "Table"){
		table_choutai2(myObj);
	}
}

//ここから下が市川せうぞーさんの名もないテクノ手を参考にしています。
function table_choutai2(myObj){
	for (var i = 0; i < myObj.cells.length; i++) {
		var txtObj = myObj.cells[i];
		var paraNum = txtObj.paragraphs.length;
		for(var p = 0;p < paraNum;p++){
			//var danraku = txtObj.paragraphs[p];
			//var gyou = txtObj.lines[p];
			for (var w=txtObj.paragraphs[p].horizontalScale; w >= 10; w--){
				txtObj.recompose();//★ここ
				var danraku_str = txtObj.paragraphs[p].contents;
				var gyou_str = txtObj.lines[p].contents;
				if (danraku_str == gyou_str) {break}
				txtObj.paragraphs[p].horizontalScale = w;
			}
		}
	}
}